% simulacija oscilatora sa vinovim mostom
% odredjivanje periode i frekvencije

astop = 10*2*pi;
astep = 0.05*pi/180;

nstep = astop/astep;

h = astep;

load "ic"

vc1(1)=ic(1);
vc2(1)=ic(2);

c1=1;
c2=2;

np1=0;
np2=0;
np3=0;
np4=0;
p1=zeros(1,10);
p2=zeros(1,10);
p3=zeros(1,10);
p4=zeros(1,10);

while c1 < nstep

	vo(c1)=vout(vc1(c1));
	vc1(c2)=vc1(c1)+h*(-2*vc1(c1)-vc2(c1)+vo(c1));
	vc2(c2)=vc2(c1)+h*(-vc1(c1)-vc2(c1)+vo(c1));

	if vc1(c1)<=0 && vc1(c2)>0
		np1=np1+1;
		p1(np1)=c1-vc1(c1)/(vc1(c2)-vc1(c1));
	end

	if vc2(c1)<=0 && vc2(c2)>0
		np2=np2+1;
		p2(np2)=c1-vc2(c1)/(vc2(c2)-vc2(c1));
	end
	
	if vc1(c1)>=0 && vc1(c2)<0
		np3=np3+1;
		p3(np3)=c1-vc1(c1)/(vc1(c2)-vc1(c1));
	end

	if vc2(c1)>=0 && vc2(c2)<0
		np4=np4+1;
		p4(np4)=c1-vc2(c1)/(vc2(c2)-vc2(c1));
	end
	
	c1=c2;
	c2=c2+1;
	
end

vo(c1)=vout(vc1(c1));

trel=(1:c1)*astep/2/pi;

figure(1)
subplot(2,1,1)
plot(trel,vc1)
axis([0 10 -10 10])
xlabel('t/T_0')
ylabel('v_{C1} [V]')
subplot(2,1,2)
plot(trel,vc2)
axis([0 10 -10 10])
xlabel('t/T_0')
ylabel('v_{C2} [V]')

figure(2)
plot(vc1,vc2)
axis([-10 10 -10 10],"square")
xlabel('v_{C1} [V]')
ylabel('v_{C2} [V]')

figure(3)
plot(trel,vo)
axis([0 10 -15 15])
xlabel('t/T_0')
ylabel('v_{OUT} [V]')

figure(4)
plot(vc1,vo)
hold on
plot(vc1,3*vc1,'r')
axis([-6 6 -18 18])
xlabel('v_{C1} [V]')
ylabel('v_{OUT} [V] (blue), 3*v_{C1} [V] (red)')
hold off

for i=1:np1-1
	T1(i)=(p1(i+1)-p1(i))*astep/2/pi;
end

for i=1:np2-1
	T2(i)=(p2(i+1)-p2(i))*astep/2/pi;
end

for i=1:np3-1
	T3(i)=(p3(i+1)-p3(i))*astep/2/pi;
end

for i=1:np4-1
	T4(i)=(p4(i+1)-p4(i))*astep/2/pi;
end


T0=[T1 T2 T3 T4];

T=mean(T0)

save T T

datper=[trel' vc1' vc2' vo' 3*vc1'];
save datper datper

ic2=[vc1(c1), vc2(c1)];
save ic2 ic2

